/*
Turbot Pipes

Turbot Pipes is an intelligence, automation & security platform built specifically for DevOps.

API version: {{OPEN_API_VERSION}}
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package pipes

import (
	"encoding/json"
)

// BillingSetupIntent struct for BillingSetupIntent
type BillingSetupIntent struct {
	ClientSecret *string `json:"client_secret,omitempty"`
	Id           *string `json:"id,omitempty"`
}

// NewBillingSetupIntent instantiates a new BillingSetupIntent object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewBillingSetupIntent() *BillingSetupIntent {
	this := BillingSetupIntent{}
	return &this
}

// NewBillingSetupIntentWithDefaults instantiates a new BillingSetupIntent object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewBillingSetupIntentWithDefaults() *BillingSetupIntent {
	this := BillingSetupIntent{}
	return &this
}

// GetClientSecret returns the ClientSecret field value if set, zero value otherwise.
func (o *BillingSetupIntent) GetClientSecret() string {
	if o == nil || o.ClientSecret == nil {
		var ret string
		return ret
	}
	return *o.ClientSecret
}

// GetClientSecretOk returns a tuple with the ClientSecret field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BillingSetupIntent) GetClientSecretOk() (*string, bool) {
	if o == nil || o.ClientSecret == nil {
		return nil, false
	}
	return o.ClientSecret, true
}

// HasClientSecret returns a boolean if a field has been set.
func (o *BillingSetupIntent) HasClientSecret() bool {
	if o != nil && o.ClientSecret != nil {
		return true
	}

	return false
}

// SetClientSecret gets a reference to the given string and assigns it to the ClientSecret field.
func (o *BillingSetupIntent) SetClientSecret(v string) {
	o.ClientSecret = &v
}

// GetId returns the Id field value if set, zero value otherwise.
func (o *BillingSetupIntent) GetId() string {
	if o == nil || o.Id == nil {
		var ret string
		return ret
	}
	return *o.Id
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BillingSetupIntent) GetIdOk() (*string, bool) {
	if o == nil || o.Id == nil {
		return nil, false
	}
	return o.Id, true
}

// HasId returns a boolean if a field has been set.
func (o *BillingSetupIntent) HasId() bool {
	if o != nil && o.Id != nil {
		return true
	}

	return false
}

// SetId gets a reference to the given string and assigns it to the Id field.
func (o *BillingSetupIntent) SetId(v string) {
	o.Id = &v
}

func (o BillingSetupIntent) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.ClientSecret != nil {
		toSerialize["client_secret"] = o.ClientSecret
	}
	if o.Id != nil {
		toSerialize["id"] = o.Id
	}
	return json.Marshal(toSerialize)
}

type NullableBillingSetupIntent struct {
	value *BillingSetupIntent
	isSet bool
}

func (v NullableBillingSetupIntent) Get() *BillingSetupIntent {
	return v.value
}

func (v *NullableBillingSetupIntent) Set(val *BillingSetupIntent) {
	v.value = val
	v.isSet = true
}

func (v NullableBillingSetupIntent) IsSet() bool {
	return v.isSet
}

func (v *NullableBillingSetupIntent) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableBillingSetupIntent(val *BillingSetupIntent) *NullableBillingSetupIntent {
	return &NullableBillingSetupIntent{value: val, isSet: true}
}

func (v NullableBillingSetupIntent) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableBillingSetupIntent) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
