/*
Turbot Pipes

Turbot Pipes is an intelligence, automation & security platform built specifically for DevOps.

API version: {{OPEN_API_VERSION}}
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package pipes

import (
	"encoding/json"
)

// CreateTriggerRequest struct for CreateTriggerRequest
type CreateTriggerRequest struct {
	// A map of arguments to be passed to be trigger.
	Args map[string]interface{} `json:"args"`
	// Optional description for the trigger.
	Description *string `json:"description,omitempty"`
	// The name of the trigger, has to be unique in a workspace.
	Name *string `json:"name,omitempty"`
	// The name / identifier of the pipeline which needs to be triggered.
	Pipeline string `json:"pipeline"`
	// The schedule at which the trigger will run.
	Schedule PipelineFrequency `json:"schedule"`
	// The state of the trigger.
	State *TriggerState `json:"state,omitempty"`
	// Optional title for the trigger.
	Title *string `json:"title,omitempty"`
}

// NewCreateTriggerRequest instantiates a new CreateTriggerRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCreateTriggerRequest(args map[string]interface{}, pipeline string, schedule PipelineFrequency) *CreateTriggerRequest {
	this := CreateTriggerRequest{}
	this.Args = args
	this.Pipeline = pipeline
	this.Schedule = schedule
	return &this
}

// NewCreateTriggerRequestWithDefaults instantiates a new CreateTriggerRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCreateTriggerRequestWithDefaults() *CreateTriggerRequest {
	this := CreateTriggerRequest{}
	return &this
}

// GetArgs returns the Args field value
func (o *CreateTriggerRequest) GetArgs() map[string]interface{} {
	if o == nil {
		var ret map[string]interface{}
		return ret
	}

	return o.Args
}

// GetArgsOk returns a tuple with the Args field value
// and a boolean to check if the value has been set.
func (o *CreateTriggerRequest) GetArgsOk() (*map[string]interface{}, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Args, true
}

// SetArgs sets field value
func (o *CreateTriggerRequest) SetArgs(v map[string]interface{}) {
	o.Args = v
}

// GetDescription returns the Description field value if set, zero value otherwise.
func (o *CreateTriggerRequest) GetDescription() string {
	if o == nil || o.Description == nil {
		var ret string
		return ret
	}
	return *o.Description
}

// GetDescriptionOk returns a tuple with the Description field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateTriggerRequest) GetDescriptionOk() (*string, bool) {
	if o == nil || o.Description == nil {
		return nil, false
	}
	return o.Description, true
}

// HasDescription returns a boolean if a field has been set.
func (o *CreateTriggerRequest) HasDescription() bool {
	if o != nil && o.Description != nil {
		return true
	}

	return false
}

// SetDescription gets a reference to the given string and assigns it to the Description field.
func (o *CreateTriggerRequest) SetDescription(v string) {
	o.Description = &v
}

// GetName returns the Name field value if set, zero value otherwise.
func (o *CreateTriggerRequest) GetName() string {
	if o == nil || o.Name == nil {
		var ret string
		return ret
	}
	return *o.Name
}

// GetNameOk returns a tuple with the Name field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateTriggerRequest) GetNameOk() (*string, bool) {
	if o == nil || o.Name == nil {
		return nil, false
	}
	return o.Name, true
}

// HasName returns a boolean if a field has been set.
func (o *CreateTriggerRequest) HasName() bool {
	if o != nil && o.Name != nil {
		return true
	}

	return false
}

// SetName gets a reference to the given string and assigns it to the Name field.
func (o *CreateTriggerRequest) SetName(v string) {
	o.Name = &v
}

// GetPipeline returns the Pipeline field value
func (o *CreateTriggerRequest) GetPipeline() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Pipeline
}

// GetPipelineOk returns a tuple with the Pipeline field value
// and a boolean to check if the value has been set.
func (o *CreateTriggerRequest) GetPipelineOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Pipeline, true
}

// SetPipeline sets field value
func (o *CreateTriggerRequest) SetPipeline(v string) {
	o.Pipeline = v
}

// GetSchedule returns the Schedule field value
func (o *CreateTriggerRequest) GetSchedule() PipelineFrequency {
	if o == nil {
		var ret PipelineFrequency
		return ret
	}

	return o.Schedule
}

// GetScheduleOk returns a tuple with the Schedule field value
// and a boolean to check if the value has been set.
func (o *CreateTriggerRequest) GetScheduleOk() (*PipelineFrequency, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Schedule, true
}

// SetSchedule sets field value
func (o *CreateTriggerRequest) SetSchedule(v PipelineFrequency) {
	o.Schedule = v
}

// GetState returns the State field value if set, zero value otherwise.
func (o *CreateTriggerRequest) GetState() TriggerState {
	if o == nil || o.State == nil {
		var ret TriggerState
		return ret
	}
	return *o.State
}

// GetStateOk returns a tuple with the State field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateTriggerRequest) GetStateOk() (*TriggerState, bool) {
	if o == nil || o.State == nil {
		return nil, false
	}
	return o.State, true
}

// HasState returns a boolean if a field has been set.
func (o *CreateTriggerRequest) HasState() bool {
	if o != nil && o.State != nil {
		return true
	}

	return false
}

// SetState gets a reference to the given TriggerState and assigns it to the State field.
func (o *CreateTriggerRequest) SetState(v TriggerState) {
	o.State = &v
}

// GetTitle returns the Title field value if set, zero value otherwise.
func (o *CreateTriggerRequest) GetTitle() string {
	if o == nil || o.Title == nil {
		var ret string
		return ret
	}
	return *o.Title
}

// GetTitleOk returns a tuple with the Title field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateTriggerRequest) GetTitleOk() (*string, bool) {
	if o == nil || o.Title == nil {
		return nil, false
	}
	return o.Title, true
}

// HasTitle returns a boolean if a field has been set.
func (o *CreateTriggerRequest) HasTitle() bool {
	if o != nil && o.Title != nil {
		return true
	}

	return false
}

// SetTitle gets a reference to the given string and assigns it to the Title field.
func (o *CreateTriggerRequest) SetTitle(v string) {
	o.Title = &v
}

func (o CreateTriggerRequest) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if true {
		toSerialize["args"] = o.Args
	}
	if o.Description != nil {
		toSerialize["description"] = o.Description
	}
	if o.Name != nil {
		toSerialize["name"] = o.Name
	}
	if true {
		toSerialize["pipeline"] = o.Pipeline
	}
	if true {
		toSerialize["schedule"] = o.Schedule
	}
	if o.State != nil {
		toSerialize["state"] = o.State
	}
	if o.Title != nil {
		toSerialize["title"] = o.Title
	}
	return json.Marshal(toSerialize)
}

type NullableCreateTriggerRequest struct {
	value *CreateTriggerRequest
	isSet bool
}

func (v NullableCreateTriggerRequest) Get() *CreateTriggerRequest {
	return v.value
}

func (v *NullableCreateTriggerRequest) Set(val *CreateTriggerRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableCreateTriggerRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableCreateTriggerRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCreateTriggerRequest(val *CreateTriggerRequest) *NullableCreateTriggerRequest {
	return &NullableCreateTriggerRequest{value: val, isSet: true}
}

func (v NullableCreateTriggerRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCreateTriggerRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
