/*
Turbot Pipes

Turbot Pipes is an intelligence, automation & security platform built specifically for DevOps.

API version: {{OPEN_API_VERSION}}
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package pipes

import (
	"encoding/json"
)

// IntegrationCommandRequest struct for IntegrationCommandRequest
type IntegrationCommandRequest struct {
	// The command to execute.
	Command IntegrationCommandAction `json:"command"`
}

// NewIntegrationCommandRequest instantiates a new IntegrationCommandRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewIntegrationCommandRequest(command IntegrationCommandAction) *IntegrationCommandRequest {
	this := IntegrationCommandRequest{}
	this.Command = command
	return &this
}

// NewIntegrationCommandRequestWithDefaults instantiates a new IntegrationCommandRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewIntegrationCommandRequestWithDefaults() *IntegrationCommandRequest {
	this := IntegrationCommandRequest{}
	return &this
}

// GetCommand returns the Command field value
func (o *IntegrationCommandRequest) GetCommand() IntegrationCommandAction {
	if o == nil {
		var ret IntegrationCommandAction
		return ret
	}

	return o.Command
}

// GetCommandOk returns a tuple with the Command field value
// and a boolean to check if the value has been set.
func (o *IntegrationCommandRequest) GetCommandOk() (*IntegrationCommandAction, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Command, true
}

// SetCommand sets field value
func (o *IntegrationCommandRequest) SetCommand(v IntegrationCommandAction) {
	o.Command = v
}

func (o IntegrationCommandRequest) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if true {
		toSerialize["command"] = o.Command
	}
	return json.Marshal(toSerialize)
}

type NullableIntegrationCommandRequest struct {
	value *IntegrationCommandRequest
	isSet bool
}

func (v NullableIntegrationCommandRequest) Get() *IntegrationCommandRequest {
	return v.value
}

func (v *NullableIntegrationCommandRequest) Set(val *IntegrationCommandRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableIntegrationCommandRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableIntegrationCommandRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableIntegrationCommandRequest(val *IntegrationCommandRequest) *NullableIntegrationCommandRequest {
	return &NullableIntegrationCommandRequest{value: val, isSet: true}
}

func (v NullableIntegrationCommandRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableIntegrationCommandRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
