/*
Turbot Pipes

Turbot Pipes is an intelligence, automation & security platform built specifically for DevOps.

API version: {{OPEN_API_VERSION}}
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package pipes

import (
	"encoding/json"
)

// ListFlowpipeInputsResponse struct for ListFlowpipeInputsResponse
type ListFlowpipeInputsResponse struct {
	Items     *[]FlowpipeInput `json:"items,omitempty"`
	NextToken *string          `json:"next_token,omitempty"`
}

// NewListFlowpipeInputsResponse instantiates a new ListFlowpipeInputsResponse object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewListFlowpipeInputsResponse() *ListFlowpipeInputsResponse {
	this := ListFlowpipeInputsResponse{}
	return &this
}

// NewListFlowpipeInputsResponseWithDefaults instantiates a new ListFlowpipeInputsResponse object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewListFlowpipeInputsResponseWithDefaults() *ListFlowpipeInputsResponse {
	this := ListFlowpipeInputsResponse{}
	return &this
}

// GetItems returns the Items field value if set, zero value otherwise.
func (o *ListFlowpipeInputsResponse) GetItems() []FlowpipeInput {
	if o == nil || o.Items == nil {
		var ret []FlowpipeInput
		return ret
	}
	return *o.Items
}

// GetItemsOk returns a tuple with the Items field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListFlowpipeInputsResponse) GetItemsOk() (*[]FlowpipeInput, bool) {
	if o == nil || o.Items == nil {
		return nil, false
	}
	return o.Items, true
}

// HasItems returns a boolean if a field has been set.
func (o *ListFlowpipeInputsResponse) HasItems() bool {
	if o != nil && o.Items != nil {
		return true
	}

	return false
}

// SetItems gets a reference to the given []FlowpipeInput and assigns it to the Items field.
func (o *ListFlowpipeInputsResponse) SetItems(v []FlowpipeInput) {
	o.Items = &v
}

// GetNextToken returns the NextToken field value if set, zero value otherwise.
func (o *ListFlowpipeInputsResponse) GetNextToken() string {
	if o == nil || o.NextToken == nil {
		var ret string
		return ret
	}
	return *o.NextToken
}

// GetNextTokenOk returns a tuple with the NextToken field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListFlowpipeInputsResponse) GetNextTokenOk() (*string, bool) {
	if o == nil || o.NextToken == nil {
		return nil, false
	}
	return o.NextToken, true
}

// HasNextToken returns a boolean if a field has been set.
func (o *ListFlowpipeInputsResponse) HasNextToken() bool {
	if o != nil && o.NextToken != nil {
		return true
	}

	return false
}

// SetNextToken gets a reference to the given string and assigns it to the NextToken field.
func (o *ListFlowpipeInputsResponse) SetNextToken(v string) {
	o.NextToken = &v
}

func (o ListFlowpipeInputsResponse) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Items != nil {
		toSerialize["items"] = o.Items
	}
	if o.NextToken != nil {
		toSerialize["next_token"] = o.NextToken
	}
	return json.Marshal(toSerialize)
}

type NullableListFlowpipeInputsResponse struct {
	value *ListFlowpipeInputsResponse
	isSet bool
}

func (v NullableListFlowpipeInputsResponse) Get() *ListFlowpipeInputsResponse {
	return v.value
}

func (v *NullableListFlowpipeInputsResponse) Set(val *ListFlowpipeInputsResponse) {
	v.value = val
	v.isSet = true
}

func (v NullableListFlowpipeInputsResponse) IsSet() bool {
	return v.isSet
}

func (v *NullableListFlowpipeInputsResponse) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableListFlowpipeInputsResponse(val *ListFlowpipeInputsResponse) *NullableListFlowpipeInputsResponse {
	return &NullableListFlowpipeInputsResponse{value: val, isSet: true}
}

func (v NullableListFlowpipeInputsResponse) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableListFlowpipeInputsResponse) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
