/*
Turbot Pipes

Turbot Pipes is an intelligence, automation & security platform built specifically for DevOps.

API version: {{OPEN_API_VERSION}}
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package pipes

import (
	"encoding/json"
)

// ListGitlabProjectsResponse struct for ListGitlabProjectsResponse
type ListGitlabProjectsResponse struct {
	Items     *[]GitlabProject `json:"items,omitempty"`
	NextToken *string          `json:"next_token,omitempty"`
}

// NewListGitlabProjectsResponse instantiates a new ListGitlabProjectsResponse object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewListGitlabProjectsResponse() *ListGitlabProjectsResponse {
	this := ListGitlabProjectsResponse{}
	return &this
}

// NewListGitlabProjectsResponseWithDefaults instantiates a new ListGitlabProjectsResponse object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewListGitlabProjectsResponseWithDefaults() *ListGitlabProjectsResponse {
	this := ListGitlabProjectsResponse{}
	return &this
}

// GetItems returns the Items field value if set, zero value otherwise.
func (o *ListGitlabProjectsResponse) GetItems() []GitlabProject {
	if o == nil || o.Items == nil {
		var ret []GitlabProject
		return ret
	}
	return *o.Items
}

// GetItemsOk returns a tuple with the Items field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListGitlabProjectsResponse) GetItemsOk() (*[]GitlabProject, bool) {
	if o == nil || o.Items == nil {
		return nil, false
	}
	return o.Items, true
}

// HasItems returns a boolean if a field has been set.
func (o *ListGitlabProjectsResponse) HasItems() bool {
	if o != nil && o.Items != nil {
		return true
	}

	return false
}

// SetItems gets a reference to the given []GitlabProject and assigns it to the Items field.
func (o *ListGitlabProjectsResponse) SetItems(v []GitlabProject) {
	o.Items = &v
}

// GetNextToken returns the NextToken field value if set, zero value otherwise.
func (o *ListGitlabProjectsResponse) GetNextToken() string {
	if o == nil || o.NextToken == nil {
		var ret string
		return ret
	}
	return *o.NextToken
}

// GetNextTokenOk returns a tuple with the NextToken field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListGitlabProjectsResponse) GetNextTokenOk() (*string, bool) {
	if o == nil || o.NextToken == nil {
		return nil, false
	}
	return o.NextToken, true
}

// HasNextToken returns a boolean if a field has been set.
func (o *ListGitlabProjectsResponse) HasNextToken() bool {
	if o != nil && o.NextToken != nil {
		return true
	}

	return false
}

// SetNextToken gets a reference to the given string and assigns it to the NextToken field.
func (o *ListGitlabProjectsResponse) SetNextToken(v string) {
	o.NextToken = &v
}

func (o ListGitlabProjectsResponse) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Items != nil {
		toSerialize["items"] = o.Items
	}
	if o.NextToken != nil {
		toSerialize["next_token"] = o.NextToken
	}
	return json.Marshal(toSerialize)
}

type NullableListGitlabProjectsResponse struct {
	value *ListGitlabProjectsResponse
	isSet bool
}

func (v NullableListGitlabProjectsResponse) Get() *ListGitlabProjectsResponse {
	return v.value
}

func (v *NullableListGitlabProjectsResponse) Set(val *ListGitlabProjectsResponse) {
	v.value = val
	v.isSet = true
}

func (v NullableListGitlabProjectsResponse) IsSet() bool {
	return v.isSet
}

func (v *NullableListGitlabProjectsResponse) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableListGitlabProjectsResponse(val *ListGitlabProjectsResponse) *NullableListGitlabProjectsResponse {
	return &NullableListGitlabProjectsResponse{value: val, isSet: true}
}

func (v NullableListGitlabProjectsResponse) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableListGitlabProjectsResponse) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
