/*
Turbot Pipes

Turbot Pipes is an intelligence, automation & security platform built specifically for DevOps.

API version: {{OPEN_API_VERSION}}
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package pipes

import (
	"encoding/json"
)

// ListSubscriptionsResponse struct for ListSubscriptionsResponse
type ListSubscriptionsResponse struct {
	Items     *[]BillingSubscription `json:"items,omitempty"`
	NextToken *string                `json:"next_token,omitempty"`
}

// NewListSubscriptionsResponse instantiates a new ListSubscriptionsResponse object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewListSubscriptionsResponse() *ListSubscriptionsResponse {
	this := ListSubscriptionsResponse{}
	return &this
}

// NewListSubscriptionsResponseWithDefaults instantiates a new ListSubscriptionsResponse object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewListSubscriptionsResponseWithDefaults() *ListSubscriptionsResponse {
	this := ListSubscriptionsResponse{}
	return &this
}

// GetItems returns the Items field value if set, zero value otherwise.
func (o *ListSubscriptionsResponse) GetItems() []BillingSubscription {
	if o == nil || o.Items == nil {
		var ret []BillingSubscription
		return ret
	}
	return *o.Items
}

// GetItemsOk returns a tuple with the Items field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListSubscriptionsResponse) GetItemsOk() (*[]BillingSubscription, bool) {
	if o == nil || o.Items == nil {
		return nil, false
	}
	return o.Items, true
}

// HasItems returns a boolean if a field has been set.
func (o *ListSubscriptionsResponse) HasItems() bool {
	if o != nil && o.Items != nil {
		return true
	}

	return false
}

// SetItems gets a reference to the given []BillingSubscription and assigns it to the Items field.
func (o *ListSubscriptionsResponse) SetItems(v []BillingSubscription) {
	o.Items = &v
}

// GetNextToken returns the NextToken field value if set, zero value otherwise.
func (o *ListSubscriptionsResponse) GetNextToken() string {
	if o == nil || o.NextToken == nil {
		var ret string
		return ret
	}
	return *o.NextToken
}

// GetNextTokenOk returns a tuple with the NextToken field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ListSubscriptionsResponse) GetNextTokenOk() (*string, bool) {
	if o == nil || o.NextToken == nil {
		return nil, false
	}
	return o.NextToken, true
}

// HasNextToken returns a boolean if a field has been set.
func (o *ListSubscriptionsResponse) HasNextToken() bool {
	if o != nil && o.NextToken != nil {
		return true
	}

	return false
}

// SetNextToken gets a reference to the given string and assigns it to the NextToken field.
func (o *ListSubscriptionsResponse) SetNextToken(v string) {
	o.NextToken = &v
}

func (o ListSubscriptionsResponse) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Items != nil {
		toSerialize["items"] = o.Items
	}
	if o.NextToken != nil {
		toSerialize["next_token"] = o.NextToken
	}
	return json.Marshal(toSerialize)
}

type NullableListSubscriptionsResponse struct {
	value *ListSubscriptionsResponse
	isSet bool
}

func (v NullableListSubscriptionsResponse) Get() *ListSubscriptionsResponse {
	return v.value
}

func (v *NullableListSubscriptionsResponse) Set(val *ListSubscriptionsResponse) {
	v.value = val
	v.isSet = true
}

func (v NullableListSubscriptionsResponse) IsSet() bool {
	return v.isSet
}

func (v *NullableListSubscriptionsResponse) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableListSubscriptionsResponse(val *ListSubscriptionsResponse) *NullableListSubscriptionsResponse {
	return &NullableListSubscriptionsResponse{value: val, isSet: true}
}

func (v NullableListSubscriptionsResponse) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableListSubscriptionsResponse) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
