/*
Turbot Pipes

Turbot Pipes is an intelligence, automation & security platform built specifically for DevOps.

API version: {{OPEN_API_VERSION}}
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package pipes

import (
	"encoding/json"
	"fmt"
)

// ModPipeling the model 'ModPipeling'
type ModPipeling string

// List of ModPipeling
const (
	ModPipelingFlowpipe  ModPipeling = "flowpipe"
	ModPipelingPowerpipe ModPipeling = "powerpipe"
)

// All allowed values of ModPipeling enum
var AllowedModPipelingEnumValues = []ModPipeling{
	"flowpipe",
	"powerpipe",
}

func (v *ModPipeling) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := ModPipeling(value)
	for _, existing := range AllowedModPipelingEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid ModPipeling", value)
}

// NewModPipelingFromValue returns a pointer to a valid ModPipeling
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewModPipelingFromValue(v string) (*ModPipeling, error) {
	ev := ModPipeling(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for ModPipeling: valid values are %v", v, AllowedModPipelingEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v ModPipeling) IsValid() bool {
	for _, existing := range AllowedModPipelingEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to ModPipeling value
func (v ModPipeling) Ptr() *ModPipeling {
	return &v
}

type NullableModPipeling struct {
	value *ModPipeling
	isSet bool
}

func (v NullableModPipeling) Get() *ModPipeling {
	return v.value
}

func (v *NullableModPipeling) Set(val *ModPipeling) {
	v.value = val
	v.isSet = true
}

func (v NullableModPipeling) IsSet() bool {
	return v.isSet
}

func (v *NullableModPipeling) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableModPipeling(val *ModPipeling) *NullableModPipeling {
	return &NullableModPipeling{value: val, isSet: true}
}

func (v NullableModPipeling) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableModPipeling) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
