/*
Turbot Pipes

Turbot Pipes is an intelligence, automation & security platform built specifically for DevOps.

API version: {{OPEN_API_VERSION}}
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package pipes

import (
	"encoding/json"
)

// UpdateAggregatorRequest struct for UpdateAggregatorRequest
type UpdateAggregatorRequest struct {
	Config *map[string]interface{} `json:"config,omitempty"`
	// The connections that are a part of the aggregator.
	Connections *[]string `json:"connections,omitempty"`
	Handle      *string   `json:"handle,omitempty"`
}

// NewUpdateAggregatorRequest instantiates a new UpdateAggregatorRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewUpdateAggregatorRequest() *UpdateAggregatorRequest {
	this := UpdateAggregatorRequest{}
	return &this
}

// NewUpdateAggregatorRequestWithDefaults instantiates a new UpdateAggregatorRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewUpdateAggregatorRequestWithDefaults() *UpdateAggregatorRequest {
	this := UpdateAggregatorRequest{}
	return &this
}

// GetConfig returns the Config field value if set, zero value otherwise.
func (o *UpdateAggregatorRequest) GetConfig() map[string]interface{} {
	if o == nil || o.Config == nil {
		var ret map[string]interface{}
		return ret
	}
	return *o.Config
}

// GetConfigOk returns a tuple with the Config field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UpdateAggregatorRequest) GetConfigOk() (*map[string]interface{}, bool) {
	if o == nil || o.Config == nil {
		return nil, false
	}
	return o.Config, true
}

// HasConfig returns a boolean if a field has been set.
func (o *UpdateAggregatorRequest) HasConfig() bool {
	if o != nil && o.Config != nil {
		return true
	}

	return false
}

// SetConfig gets a reference to the given map[string]interface{} and assigns it to the Config field.
func (o *UpdateAggregatorRequest) SetConfig(v map[string]interface{}) {
	o.Config = &v
}

// GetConnections returns the Connections field value if set, zero value otherwise.
func (o *UpdateAggregatorRequest) GetConnections() []string {
	if o == nil || o.Connections == nil {
		var ret []string
		return ret
	}
	return *o.Connections
}

// GetConnectionsOk returns a tuple with the Connections field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UpdateAggregatorRequest) GetConnectionsOk() (*[]string, bool) {
	if o == nil || o.Connections == nil {
		return nil, false
	}
	return o.Connections, true
}

// HasConnections returns a boolean if a field has been set.
func (o *UpdateAggregatorRequest) HasConnections() bool {
	if o != nil && o.Connections != nil {
		return true
	}

	return false
}

// SetConnections gets a reference to the given []string and assigns it to the Connections field.
func (o *UpdateAggregatorRequest) SetConnections(v []string) {
	o.Connections = &v
}

// GetHandle returns the Handle field value if set, zero value otherwise.
func (o *UpdateAggregatorRequest) GetHandle() string {
	if o == nil || o.Handle == nil {
		var ret string
		return ret
	}
	return *o.Handle
}

// GetHandleOk returns a tuple with the Handle field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UpdateAggregatorRequest) GetHandleOk() (*string, bool) {
	if o == nil || o.Handle == nil {
		return nil, false
	}
	return o.Handle, true
}

// HasHandle returns a boolean if a field has been set.
func (o *UpdateAggregatorRequest) HasHandle() bool {
	if o != nil && o.Handle != nil {
		return true
	}

	return false
}

// SetHandle gets a reference to the given string and assigns it to the Handle field.
func (o *UpdateAggregatorRequest) SetHandle(v string) {
	o.Handle = &v
}

func (o UpdateAggregatorRequest) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Config != nil {
		toSerialize["config"] = o.Config
	}
	if o.Connections != nil {
		toSerialize["connections"] = o.Connections
	}
	if o.Handle != nil {
		toSerialize["handle"] = o.Handle
	}
	return json.Marshal(toSerialize)
}

type NullableUpdateAggregatorRequest struct {
	value *UpdateAggregatorRequest
	isSet bool
}

func (v NullableUpdateAggregatorRequest) Get() *UpdateAggregatorRequest {
	return v.value
}

func (v *NullableUpdateAggregatorRequest) Set(val *UpdateAggregatorRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableUpdateAggregatorRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableUpdateAggregatorRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableUpdateAggregatorRequest(val *UpdateAggregatorRequest) *NullableUpdateAggregatorRequest {
	return &NullableUpdateAggregatorRequest{value: val, isSet: true}
}

func (v NullableUpdateAggregatorRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableUpdateAggregatorRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
