/*
Turbot Pipes

Turbot Pipes is an intelligence, automation & security platform built specifically for DevOps.

API version: {{OPEN_API_VERSION}}
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package pipes

import (
	"encoding/json"
)

// UpdateIntegrationRequest struct for UpdateIntegrationRequest
type UpdateIntegrationRequest struct {
	// The configuration for the integration.
	Config *map[string]interface{} `json:"config,omitempty"`
	// The handle for the integration.
	Handle *string `json:"handle,omitempty"`
	// The state of the integration.
	State *IntegrationState `json:"state,omitempty"`
}

// NewUpdateIntegrationRequest instantiates a new UpdateIntegrationRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewUpdateIntegrationRequest() *UpdateIntegrationRequest {
	this := UpdateIntegrationRequest{}
	return &this
}

// NewUpdateIntegrationRequestWithDefaults instantiates a new UpdateIntegrationRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewUpdateIntegrationRequestWithDefaults() *UpdateIntegrationRequest {
	this := UpdateIntegrationRequest{}
	return &this
}

// GetConfig returns the Config field value if set, zero value otherwise.
func (o *UpdateIntegrationRequest) GetConfig() map[string]interface{} {
	if o == nil || o.Config == nil {
		var ret map[string]interface{}
		return ret
	}
	return *o.Config
}

// GetConfigOk returns a tuple with the Config field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UpdateIntegrationRequest) GetConfigOk() (*map[string]interface{}, bool) {
	if o == nil || o.Config == nil {
		return nil, false
	}
	return o.Config, true
}

// HasConfig returns a boolean if a field has been set.
func (o *UpdateIntegrationRequest) HasConfig() bool {
	if o != nil && o.Config != nil {
		return true
	}

	return false
}

// SetConfig gets a reference to the given map[string]interface{} and assigns it to the Config field.
func (o *UpdateIntegrationRequest) SetConfig(v map[string]interface{}) {
	o.Config = &v
}

// GetHandle returns the Handle field value if set, zero value otherwise.
func (o *UpdateIntegrationRequest) GetHandle() string {
	if o == nil || o.Handle == nil {
		var ret string
		return ret
	}
	return *o.Handle
}

// GetHandleOk returns a tuple with the Handle field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UpdateIntegrationRequest) GetHandleOk() (*string, bool) {
	if o == nil || o.Handle == nil {
		return nil, false
	}
	return o.Handle, true
}

// HasHandle returns a boolean if a field has been set.
func (o *UpdateIntegrationRequest) HasHandle() bool {
	if o != nil && o.Handle != nil {
		return true
	}

	return false
}

// SetHandle gets a reference to the given string and assigns it to the Handle field.
func (o *UpdateIntegrationRequest) SetHandle(v string) {
	o.Handle = &v
}

// GetState returns the State field value if set, zero value otherwise.
func (o *UpdateIntegrationRequest) GetState() IntegrationState {
	if o == nil || o.State == nil {
		var ret IntegrationState
		return ret
	}
	return *o.State
}

// GetStateOk returns a tuple with the State field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UpdateIntegrationRequest) GetStateOk() (*IntegrationState, bool) {
	if o == nil || o.State == nil {
		return nil, false
	}
	return o.State, true
}

// HasState returns a boolean if a field has been set.
func (o *UpdateIntegrationRequest) HasState() bool {
	if o != nil && o.State != nil {
		return true
	}

	return false
}

// SetState gets a reference to the given IntegrationState and assigns it to the State field.
func (o *UpdateIntegrationRequest) SetState(v IntegrationState) {
	o.State = &v
}

func (o UpdateIntegrationRequest) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Config != nil {
		toSerialize["config"] = o.Config
	}
	if o.Handle != nil {
		toSerialize["handle"] = o.Handle
	}
	if o.State != nil {
		toSerialize["state"] = o.State
	}
	return json.Marshal(toSerialize)
}

type NullableUpdateIntegrationRequest struct {
	value *UpdateIntegrationRequest
	isSet bool
}

func (v NullableUpdateIntegrationRequest) Get() *UpdateIntegrationRequest {
	return v.value
}

func (v *NullableUpdateIntegrationRequest) Set(val *UpdateIntegrationRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableUpdateIntegrationRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableUpdateIntegrationRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableUpdateIntegrationRequest(val *UpdateIntegrationRequest) *NullableUpdateIntegrationRequest {
	return &NullableUpdateIntegrationRequest{value: val, isSet: true}
}

func (v NullableUpdateIntegrationRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableUpdateIntegrationRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
